;+
; .. _subdctn_cs_validation_net_1991_93_all_v10.pro:
;
; =============================================
; subdctn_cs_validation_net_1991_93_all_v10.pro
; =============================================
;
; DESCRIPTION
; ===========
;
; .. graphviz::
;
;    digraph subdctn_cs_validation_net_1991_93_all_v10 {
;       graph [
;       rankdir="LR",
;       ]
;       met_data [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/met_data_subduct_cs_9*.txt"];
;       swr_erai [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/erai_swr_19910101_20091231_oafluxgrid.nc"];
;       lwr_erai [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/erai_lwr_19910101_20091231_oafluxgrid.nc"];
;       lhf_erai [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/erai_lhf_19910101_20091231_oafluxgrid.nc"];
;       shf_erai [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/erai_shf_19910101_20091231_oafluxgrid.nc"];
;       tropflux_general [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/TropFlux_19890101_20091231.nc"];
;       swr_tropflux_nrt [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/TropFlux_swr_19890101_20091231_NRT_v50.nc"];
;       swr_oafluxgrid [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/swr_oafluxgrid_1985_2007.nc"];
;       lwr_oafluxgrid [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/lwr_oafluxgrid_1985_2007.nc"];
;       lhf_oafluxgrid [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/lhf_oafluxgrid_1985_2007.nc"];
;       shf_oafluxgrid [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/shf_oafluxgrid_1985_2007.nc"];
;       swr_ncep2 [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/swr_ncep2_oaflxgrid_19890101_20091231.nc"];
;       lwr_ncep2 [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/NCEP2_flux_19890101_20090729.nc"];
;       lhf_ncep2 [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/lhf_ncep2_oafluxgrid_19890101_20091231.nc"];
;       shf_ncep2 [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/shf_ncep2_oafluxgrid_19890101_20091231.nc"];
;
;       ncep1 [shape=ellipse,fontname=Courier,label="${PROJECT_ID}/ncep1_flux_19890101_20091231.nc"];
;
;       figure [shape=ellipse,fontname=Courier,label="${PROJECT_OD}/subdctn_cs_validation_net_1991_93_all_v10.ps"];
;
;       subdctn_cs_validation_net_1991_93_all_v10 [shape=box,
;       fontname=Courier,
;       color=blue,
;       URL="http://forge.ipsl.jussieu.fr/tropflux/broswrer/trunk/src/paper01/fig14/subdctn_cs_validation_net_1991_93_all_v10.pro",
;       label="${TROPFLUX}/src/paper01/fig14/subdctn_cs_validation_net_1991_93_all_v10.pro"];
;
;       {met_data swr_erai  lwr_erai lhf_erai shf_erai tropflux_general swr_tropflux_nrt swr_oafluxgrid lwr_oafluxgrid lhf_oafluxgrid shf_oafluxgrid swr_ncep2 lwr_ncep2 lhf_ncep2 shf_ncep2 ncep1} -> {subdctn_cs_validation_net_1991_93_all_v10} -> {figure}
;    }
;
; SEE ALSO
; ========
;
; :ref:`project_profile.sh`
; :ref:`project_init.pro`
; :ref:`cm_project.pro`
;
; :ref:`statistics.pro`
;
; EXAMPLES
; ========
;
; ::
;
;  IDL> subdctn_cs_validation_net_1991_93_all_v10
;
; TODO
; ====
;
; make it work on cratos : missing data
;
; coding rules
;
; get rid of spwan
;
; complete description
;
; handle IO error
;
; EVOLUTIONS
; ==========
;
; $Id$
;
; - fplod 20110420T121121Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * remove hard coding path
;   * add graphviz
;
; - fplod 20110411T142955Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * minimal header
;
;-
pro subdctn_cs_validation_net_1991_93_all_v10
@cm_general
@cm_project
reinitplt, /z,/invert
key_portrait = 1
coefpalit=.9

openps, FILENAME = 'idl.ps'
; partie a changer

;; subduction experiment in the atlantic in 1991-93
box=[330.5, 331.5, 25., 26.]

;; first leg

fi=project_id_env+"met_data_subduct_cs_91.txt"
res=read_ascii(fi,data_start=1)
ff=res.field1
swr_91=reform(ff(7,*))/0.94
lhf_91=reform(ff(5,*))
shf_91=reform(ff(6,*))
lwr_91=reform(ff(8,*))
net_91=[swr_91+lwr_91+shf_91+lhf_91]

;; start data - 06/02/92 and end date 02/06/92 then from 11/10/92 to 31/12/92
;; total no of daily records -
;; second leg

fi=project_id_env+"met_data_subduct_cs_92.txt"
res=read_ascii(fi,data_start=1)
ff=res.field1
swr_92=reform(ff(7,*))/0.94
lhf_92=reform(ff(5,*))
shf_92=reform(ff(6,*))
lwr_92=reform(ff(8,*))
net_92=[swr_92+lwr_92+shf_92+lhf_92]

;; second leg

fi=project_id_env+"met_data_subduct_cs_93.txt"
res=read_ascii(fi,data_start=1)
ff=res.field1
swr_93=reform(ff(7,*))/0.94
lhf_93=reform(ff(5,*))
shf_93=reform(ff(6,*))
lwr_93=reform(ff(8,*))
net_93=[swr_93+lwr_93+shf_93+lhf_93]

net=[net_91, net_92, net_93]
help, net

;; reading other data sets

st1=19910623 & en1=19930616

file=project_id_env+"erai_swr_19910101_20091231_oafluxgrid.nc"
initncdf, file
swr1=read_ncdf('swr',st1,en1,file=file,/nostr, box=box) & swr1=grossemoyenne(swr1, "xy", box=box,/nan) & swr1=reform(swr1)
file=project_id_env+'erai_lhf_19890101_20091231_oafluxgrid.nc'
initncdf, file
lhf1=-1*read_ncdf('lhf',st1,en1,file=file,/nostr, box=box) & lhf1=grossemoyenne(lhf1, "xy", box=box,/nan) & lhf1=reform(lhf1)
file=project_id_env+'erai_shf_19890101_20091231_oafluxgrid.nc'
initncdf, file
shf1=-1*read_ncdf('shf',st1,en1,file=file,/nostr, box=box) & shf1=grossemoyenne(shf1, "xy", box=box,/nan) & shf1=reform(shf1)
file=project_id_env+'erai_lwr_19890101_20091231_oafluxgrid.nc'
initncdf, file
lwr1=read_ncdf('lwr',st1-1,en1,file=file,/nostr, box=box) & lwr1=grossemoyenne(lwr1, "xy", box=box,/nan) & lwr1=reform(lwr1)

era=swr1+lwr1+lhf1+shf1
swr1=0 & lwr1=0 & shf1=0 & lhf1=0
help, era

file=project_id_env+"TropFlux_19890101_20091231.nc"
initncdf, file
lhf1=read_ncdf('lhf',st1,en1,file=file,/nostr, box=box) & lhf1=grossemoyenne(lhf1, "xy", box=box,/nan) & lhf1=reform(lhf1)
shf1=read_ncdf('shf',st1,en1,file=file,/nostr, box=box) & shf1=grossemoyenne(shf1, "xy", box=box,/nan) & shf1=reform(shf1)
lwr1=read_ncdf('lwr',st1,en1,file=file,/nostr, box=box) & lwr1=grossemoyenne(lwr1, "xy", box=box,/nan) & lwr1=reform(lwr1)
swr1=read_ncdf('swr',st1,en1,file=file,/nostr, box=box) & swr1=grossemoyenne(swr1, "xy", box=box,/nan) & swr1=reform(swr1)
trop=swr1+lwr1+lhf1+shf1

file=project_id_env+"TropFlux_swr_19890101_20091231_NRT_v50.nc"
initncdf, file
olr1=read_ncdf("sw", st1-1, en1, file=file,/nostr, box=box) & olr1=grossemoyenne(olr1, "xy",/nan, box=box) & olr1=reform(olr1)

olr=olr1+lwr1+shf1+lhf1
help, trop, olr
swr1=0 & lwr1=0 & shf1=0 & lhf1=0 & olr1=0

file=project_id_env+'swr_oafluxgrid_1985_2007.nc'
initncdf, file
swr1=read_ncdf("swr", st1, en1, file=file,/nostr, box=box) & swr1=grossemoyenne(swr1, "xy",/nan, box=box) & swr1=reform(swr1)
file=project_id_env+'lwr_oafluxgrid_1985_2007.nc'
initncdf, file
lwr1=-1*read_ncdf("lwr", st1, en1, file=file,/nostr, box=box) & lwr1=grossemoyenne(lwr1, "xy",/nan, box=box) & lwr1=reform(lwr1)
file=project_id_env+'lhf_oafluxgrid_1985_2009.nc'
initncdf, file
lhf1=-1*read_ncdf("lhf", st1, en1, file=file,/nostr, box=box) & lhf1=grossemoyenne(lhf1, "xy",/nan, box=box) & lhf1=reform(lhf1)
file=project_id_env+'shf_oafluxgrid_1985_2009.nc'
initncdf, file
shf1=-1*read_ncdf("shf", st1, en1, file=file,/nostr, box=box) & shf1=grossemoyenne(shf1, "xy",/nan, box=box) & shf1=reform(shf1)

oaf=swr1+lwr1+lhf1+shf1
help, oaf
swr1=0 & lwr1=0 & shf1=0 & lhf1=0 & olr1=0

fi=project_id_env+'swr_ncep2_oaflxgrid_19890101_20091231.nc'
initncdf, fi
swr1=read_ncdf("swr", st1, en1, file=fi,/nostr, box=box) & swr1=grossemoyenne(swr1, "xy",/nan, box=box) & swr1=reform(swr1)
fi=project_id_env+"NCEP2_flux_19890101_20090729.nc"
initncdf, fi
lwr1=-1*read_ncdf("lwr", st1, en1, file=fi,/nostr, box=box) & lwr1=grossemoyenne(lwr1, "xy",/nan, box=box) & lwr1=reform(lwr1)
fi=project_id_env+'lhf_ncep2_oafluxgrid_19890101_20091231.nc'
initncdf, fi
lhf1=-1*read_ncdf("lhf", st1, en1, file=fi,/nostr, box=box) & lhf1=grossemoyenne(lhf1, "xy",/nan, box=box) & lhf1=reform(lhf1)
fi=project_id_env+'shf_ncep2_oafluxgrid_19890101_20091231.nc'
initncdf, fi
shf1=-1*read_ncdf("shf", st1, en1, file=fi,/nostr, box=box) & shf1=grossemoyenne(shf1, "xy",/nan, box=box) & shf1=reform(shf1)

nce2=swr1+lwr1+lhf1+shf1
help, nce2
swr1=0 & lwr1=0 & shf1=0 & lhf1=0 & olr1=0

file=project_id_env+"ncep1_flux_19890101_20091231.nc"
initncdf, file

lhf1=read_ncdf('lhf',st1,en1,file=file,/nostr, box=box) & lhf1=grossemoyenne(lhf1, "xy", box=box,/nan) & lhf1=reform(lhf1)
shf1=read_ncdf('shf',st1,en1,file=file,/nostr, box=box) & shf1=grossemoyenne(shf1, "xy", box=box,/nan) & shf1=reform(shf1)
lwr1=read_ncdf('lwr',st1,en1,file=file,/nostr, box=box) & lwr1=grossemoyenne(lwr1, "xy", box=box,/nan) & lwr1=reform(lwr1)
swr1=read_ncdf('swr',st1,en1,file=file,/nostr, box=box) & swr1=grossemoyenne(swr1, "xy", box=box,/nan) & swr1=reform(swr1)
nce1=swr1+(lwr1+shf1+lhf1)
help, nce1

ind=where(finite(net))
net=net(ind) & era=era(ind) & trop=trop(ind) & oaf=oaf(ind) & nce2=nce2(ind) & nce1=nce1(ind)
olr=olr(ind)

statistics, net, era, $
                 cor, bias, std, rmsd
print, cor, bias, std,  rmsd
cstat_era=string(cor, bias, std, rmsd, format='(f4.2,2x,f6.2,2x,f4.2,1x,f6.2)')

statistics, net, trop, $
                 cor, bias, std, rmsd
print, cor, bias, std,  rmsd
cstat_trop=string(cor, bias, std, rmsd, format='(f4.2,2x,f6.2,2x,f4.2,1x,f6.2)')

statistics, net, oaf, $
                 cor, bias, std, rmsd
print, cor, bias, std,  rmsd
cstat_oaf=string(cor, bias, std, rmsd, format='(f4.2,2x,f6.2,2x,f4.2,1x,f6.2)')

statistics, net, nce1, $
                 cor, bias, std, rmsd
print, cor, bias, std,  rmsd
cstat_nce1=string(cor, bias, std, rmsd, format='(f4.2,2x,f6.2,2x,f4.2,1x,f6.2)')

statistics, net, nce2, $
                 cor, bias, std, rmsd
print, cor, bias, std,  rmsd
cstat_nce2=string(cor, bias, std, rmsd, format='(f4.2,2x,f6.2,2x,f4.2,1x,f6.2)')

statistics, net, olr, $
                 cor, bias, std, rmsd
print, cor, bias, std,  rmsd
cstat_olr=string(cor, bias, std, rmsd, format='(f4.2,2x,f6.2,2x,f4.2,1x,f6.2)')


splot, net, era, charsize=1.1, title='Net Flux - Subdn. cs Vs ERAI', $
     xrange=[-200,200], yrange=[-200,200], small=[2,3,1], psym=2, xmin=1, ymin=1
oplot, [-200,200], [-200,200]
xyouts, 0,-175, cstat_era, charsize=1.

splot, net, trop, charsize=1.1, title='Net Flux - Subdn. cs Vs TropFlux',/noer, $
     xrange=[-200,200], yrange=[-200,200], small=[2,3,2], psym=2, xmin=1, ymin=1
oplot, [-200,200], [-200,200]
xyouts, 0,-175, cstat_trop, charsize=1.

splot, net, oaf, charsize=1.1, title='Net Flux - Subdn. cs Vs OAFlux',/noer, $
     xrange=[-200,200], yrange=[-200,200], small=[2,3,3], psym=2, xmin=1, ymin=1
oplot, [-200,200], [-200,200]
xyouts, 0,-175, cstat_oaf, charsize=1.

splot, net, nce1, charsize=1.1, title='Net Flux - Subdn. cs Vs NCEP1',/noer, $
     xrange=[-200,200], yrange=[-200,200], small=[2,3,4], psym=2, xmin=1, ymin=1
oplot, [-200,200], [-200,200]
xyouts, 0,-175, cstat_nce1, charsize=1.

splot, net, nce2, charsize=1.1, title='Net Flux - Subdn. cs Vs NCEP2',/noer, $
     xrange=[-200,200], yrange=[-200,200], small=[2,3,5], psym=2, xmin=1, ymin=1
oplot, [-200,200], [-200,200]
xyouts, 0,-175, cstat_nce2, charsize=1.

splot, net, olr, charsize=1.1, title='Net Flux - Subdn. cs Vs TropFlux_NRT',/noer, $
     xrange=[-200,200], yrange=[-200,200], small=[2,3,6], psym=2, xmin=1, ymin=1
oplot, [-200,200], [-200,200]
xyouts, 0,-175, cstat_olr, charsize=1.

closeps
fig=project_od_env+"subdctn_cs_validation_net_1991_93_all_v10.ps"
spawn, 'mv '+psdir+'idl.ps '+fig
spawn, 'gv '+fig
end
